const MaxP = ...;
type SetOfPoints = array [1..MaxP] of point;

procedure ClosestPair(var A, work: SetOfPoints; n: integer;
                      var p1, p2: point; var d: real);
  (* Find the closest pair from among n points in O(n log n) time. *)
  (* p1 and p2 keep track of the closest points and d of their distance. *)
  (* NOTE: the contents of A are destroyed. *)
  var i: integer; MinX, MaxX: real; (* dummy variables *)

  procedure RecClosestPair(    l, r: integer;
                           var newr: integer; var MinX, MaxX: real);
    (* Find the closest pair of points in A[l..r], which is sorted by abscissae.
       On return, A[l..newr] contains the points, sorted by ordinates, which lie
       within d of the boundaries of the vertical strip [MinX,MaxX]. *)
    var m, newml, newmr: integer;
        MaxX1, MinX2: real;

    procedure Merge(l1, r1, l2, r2: integer; var newr: integer;
                    MinX, MaxX1, MinX2, MaxX: real);
      (* Check for closest pairs among A[l1..r1] and A[l2..r2] and merge. *)
      begin
        ... no code shown for this routine ...
        (* The partitioning line is a no-man's-land between MaxX1 and MinX2. *)
        (* Scan both lists and place at the front of the work array, preserving
           the ordering by ordinates, the points of subproblem 1 that lie within d
           of MinX2 and the points of subproblem 2 that lie within d of MaxX1. *)
        (* Scan the work array and update global variables p1, p2, and d. *)
        (* Merge the two sorted lists, retaining only points within d of the
           boundaries of the new vertical strip. *)
      end; (* Merge *)

    begin (* RecClosestPair *)
      if l = r
        then begin newr := r; MinX := A[l].x; MaxX := MinX end
        else begin
               m := (l+r) div 2;
               RecClosestPair(l,m,newml,MinX,MaxX1);
               RecClosestPair(m+1,r,newmr,MinX2,MaxX);
               Merge(l,newml,m+1,newmr,newr,MinX,MaxX1,MinX2,MaxX)
             end
    end; (* RecClosestPair *)

  begin (* ClosestPair *)
    ...; (* Sort the points by their abscissae. *)
    d := infinity; (* suitable constant *)
    RecClosestPair(1,n,i,MinX,MaxX)
  end; (* ClosestPair *)
