function Theta(p1,p2: point): real; external;
  (* Return the pseudo-angle between the y-axis, with orientation down as
     positive, p1 (as origin) and p2.

     The pseudo-angle has the property that the ordering of points by
     true angle around the origin and the ordering of points by the
     pseudo-angle are the same.

     Result returned is in [0,4) (or error condition).
  *)

function PolarCompare(p,p1,p2: point): real; external;
  (* Using  p  as the origin determine the relationship between  p1  and
      p2  in polar coordinates.  Primary key is angle (with downwards
      y-axis being the logical x-axis) and secondary key is radius.
  *)
