procedure MergeSort(var A, work: data; n: integer);
  (* iterative, bottom-up mergesort algorithm *)
  var inA: boolean; (* where the data currently reside *)
      span, (* current length of sorted lists *)
      i: integer;

  procedure Merge(var inarray, (* lists of length span *)
                      outarray: (* upon return, lists of length 2*span *)
                        data;
                      n, (* total number of elements *)
                      span: integer);
    (* Merge pairs of sorted lists of length span.  The merge operation is
       performed slightly more efficiently than in the previous program. *)
    label 99;
    var i, (* points to first unprocessed element in sublist 1 *)
        j, (* points to first unprocessed element in sublist 2 *)
        k, (* points to first free space in the output list *)
        t, (* location past first sublist/start of second sublist *)
        u: (* location past second sublist *)
          integer;
    begin
      (* There are at least two lists to merge. *)
      i := 1; j := span + 1; k := 1;

      repeat (* until there is at most one list left over *)
        (* Invariant: k = i at the start of the merge operation. *)
        (* Set upper bounds for i and j. *)
        t := j; u := j + span; if u > n then u := n + 1;
    99: if inarray[i] <= inarray[j]
          then begin
                 outarray[k] := inarray[i]; i := i + 1; k := k + 1;
                 if i < t (* only check pointer that changed *)
                   then goto 99
                   else repeat (* copy remainder of sublist 2 *)
                          outarray[k] := inarray[k]; (* k = j at this point *)
                          k := k + 1
                        until k = u
               end
          else begin
                 outarray[k] := inarray[j]; j := j + 1; k := k + 1;
                 if j < u (* only check pointer that changed *)
                   then goto 99
                   else repeat (* copy remainder of sublist 1 *)
                          outarray[k] := inarray[i]; i := i + 1; k := k + 1
                        until k = u
               end;
        i := u; j := i + span
      until j > n; (* until sublist 2 is nonexistent *)
      (* Copy over an unmatched list, if one exists. *)
      for j := i to n do outarray[j] := inarray[j]
    end; (* Merge *)
  begin (* MergeSort *)
    inA := true; (* The data are initially in A. *)
    span := 1; (* The array consists of n sublists of length one. *)
    while span < n do (* while we cannot guarantee that the array is sorted *)
      begin
        if inA
          then Merge(A,work,n,span)
          else Merge(work,A,n,span);
        inA := not inA;
        span := 2*span
      end;
    (* If the final result is in the wrong array, then transfer it back. *)
    if not inA then for i := 1 to n do A[i] := work[i]
  end; (* MergeSort *)
