procedure MergeSort(var A, work: data; n: integer);
  (* recursive, top-down mergesort algorithm *)

  procedure RecMergeSort(left, right: integer);
    (* Sort A[left..right] using mergesort. *)
    var middle: integer;

    procedure Merge(s, n, m: integer);
      (* Merge A[s..s+n-1] and A[s+n..s+n+m-1], two adjacent sorted sublists,
         of lengths n and m, putting the result in A[s..s+n+m-1]. *)
      var i, (* points to first unprocessed element of sublist 1 *)
          j, (* points to first unprocessed element of sublist 2 *)
          k, (* points to first free space in the output list *)
          t, (* location past first sublist/start of second sublist *)
          u: (* location past second sublist *)
            integer;
      begin
        (* Merge the data into the start of the work array. *)
        k := 1; t := s + n; u := t + m; i := s; j := t;
        while (i < t) and (j < u) do
          if A[i] <= A[j]
            then begin work[k] := A[i]; i := i + 1; k := k + 1 end
            else begin work[k] := A[j]; j := j + 1; k := k + 1 end;
        while i < t do (* Copy any leftover portion of the first segment. *)
          begin work[k] := A[i]; i := i + 1; k := k + 1 end;
        while j < u do (* Copy any left over portion of the second segment. *)
          begin work[k] := A[j]; j := j + 1; k := k + 1 end;
        (* Move merged lists back into A[s..s+n+m]. *)
        i := s;
        for j := 1 to k do begin A[i] := work[j]; i := i + 1 end
      end; (* Merge *)

    begin (* RecMergeSort *)
      if left < right (* Segments of length one are sorted by default. *)
        then begin
               middle := (left + right) div 2;
               RecMergeSort(left,middle);
               RecMergeSort(middle+1,right);
               Merge(left,middle-left+1,right-middle)
             end
    end; (* RecMergeSort *)

  begin
    RecMergeSort(1,n)
  end; (* MergeSort *)
